// Fig 16.6: ShowColors.cs
// Color value and alpha demonstration.
using System;
using System.Drawing;
using System.Windows.Forms;

public partial class ShowColors : Form
{
   // color for back rectangle
   private Color backColor = Color.Wheat;

   // color for front rectangle
   private Color frontColor = Color.FromArgb( 100, 0, 0, 255 );

   // default constructor
   public ShowColors()
   {
      InitializeComponent();
   } // end constructor

   // override Form OnPaint method
   protected override void OnPaint( PaintEventArgs e )
   {
      Graphics graphicsObject = e.Graphics; // get graphics

      // create text brush
      SolidBrush textBrush = new SolidBrush( Color.Black ); 

      // create solid brush
      SolidBrush brush = new SolidBrush( Color.White );

      // draw white background
      graphicsObject.FillRectangle( brush, 4, 4, 275, 180 );

      // display name of backColor
      graphicsObject.DrawString( backColor.Name, this.Font,
         textBrush, 40, 5 );

      // set brush color and display back rectangle
      brush.Color = backColor;
      graphicsObject.FillRectangle( brush, 45, 20, 150, 120 );

      // display Argb values of front color
      graphicsObject.DrawString( "Alpha: " + frontColor.A +
         " Red: " + frontColor.R + " Green: " + frontColor.G + 
         " Blue: " + frontColor.B, this.Font, textBrush, 55, 165 );

      // set brush color and display front rectangle
      brush.Color = frontColor;
      graphicsObject.FillRectangle( brush, 65, 35, 170, 130 );
   } // end method OnPaint

   // handle colorNameButton click event
   private void colorNameButton_Click( object sender, EventArgs e )
   {
      // set backColor to color specified in text box
      backColor = Color.FromName( colorNameTextBox.Text );

      Invalidate(); // refresh Form
   } // end method colorNameButton_Click

   // handle colorValueButton click event
   private void colorValueButton_Click( object sender, EventArgs e )
   {
      // obtain new front color from text boxes
      frontColor = Color.FromArgb( 
         Convert.ToInt32( alphaTextBox.Text ),
         Convert.ToInt32( redTextBox.Text ),
         Convert.ToInt32( greenTextBox.Text ),
         Convert.ToInt32( blueTextBox.Text ) );

      Invalidate(); // refresh Form
   } // end method colorValueButton_Click
} // end class ShowColors


/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/