// Fig. 22.20: ReservationService.cs
// Airline reservation Web Service.
using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

[ WebService( Namespace = "http://www.deitel.com/", Description =
   "Service that enables a user to reserve a seat on a plane." ) ]
[ WebServiceBinding( ConformsTo = WsiProfiles.BasicProfile1_1 ) ]
public class ReservationService : System.Web.Services.WebService
{
   // create TicketsDataSet object for caching data 
   // from the Tickets database
   private TicketsDataSet ticketsDataSet = new TicketsDataSet();

   // create SeatsTableAdapter for interacting with the database
   private TicketsDataSetTableAdapters.SeatsTableAdapter 
      SeatsTableAdapter = 
      new TicketsDataSetTableAdapters.SeatsTableAdapter();

   // checks database to determine whether matching seat is available
   [ WebMethod( Description = "Method to reserve a seat." ) ] 
   public bool Reserve( string seatType, string classType ) 
   {
      // fill TicketsDataSet.Seats with rows that represent untaken
      // seats that match the specified seatType and classType
      SeatsTableAdapter.FillByTypeAndClass(
         ticketsDataSet.Seats, seatType, classType );

      // if the number of seats returned is nonzero, 
      // obtain the first matching seat number and mark it as taken
      if ( ticketsDataSet.Seats.Count != 0 ) 
      {
         string seatNumber = ticketsDataSet.Seats[ 0 ].Number;

         SeatsTableAdapter.UpdateSeatAsTaken( seatNumber );
         return true; // seat was reserved
      } // end if

      return false; // no seat was reserved
   } // end method Reserve
} // end class ReservationService

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/
