// Fig. 22.26: Equation.cs
// Class Equation that contains information about an equation.
using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public class Equation
{
   private int leftOperand; // number to the left of the operator
   private int rightOperand; // number to the right of the operator
   private int resultValue; // result of the operation
   private string operationType; // type of the operation

   // required default constructor
   public Equation()
      : this( 0, 0, "+" )
   {
      // empty body
   } // end default constructor

   // three-argument constructor for class Equation
   public Equation( int leftValue, int rightValue, string type )
   {
      leftOperand = leftValue;
      rightOperand = rightValue;
      operationType = type;

      switch ( operationType ) // perform appropriate operation
      {
         case "+": // addition
            resultValue = leftOperand + rightOperand;
            break;
         case "-": // subtraction
            resultValue = leftOperand - rightOperand;
            break;
         case "*": // multiplication
            resultValue = leftOperand * rightOperand;
            break;
      } // end switch
   } // end three-argument constructor

   // return string representation of the Equation object
   public override string ToString() 
   {
      return leftOperand.ToString() + " " + operationType + " " +
         rightOperand.ToString() + " = " + resultValue.ToString();
   } // end method ToString

   // property that returns a string representing left-hand side
   public string LeftHandSide
   {
      get
      {
         return leftOperand.ToString() + " " + operationType + " " +
            rightOperand.ToString();
      } // end get

      set // required set accessor
      {
         // empty body
      } // end set
   } // end property LeftHandSide

   // property that returns a string representing right-hand side
   public string RightHandSide
   {
      get
      {
         return resultValue.ToString();
      } // end get

      set // required set accessor
      {
         // empty body
      } // end set
   } // end property RightHandSide

   // property to access the left operand 
   public int Left
   {
      get
      {
         return leftOperand;
      } // end get

      set
      {
         leftOperand = value;
      } // end set
   } // end property Left

   // property to access the right operand 
   public int Right
   {
      get
      {
         return rightOperand;
      } // end get

      set
      {
         rightOperand = value;
      } // end set
   } // end property Right

   // property to access the result of applying
   // an operation to the left and right operands
   public int Result
   {
      get
      {
         return resultValue;
      } // end get

      set
      {
         resultValue = value;
      } // end set
   } // end property Result

   // property to access the operation
   public string Operation
   {
      get
      {
         return operationType;
      } // end get

      set
      {
         operationType = value;
      } // end set
   } // end property Operation
} // end class Equation

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/
