// Fig. 22.27: Generator.cs
// Web Service to generate random equations based on a specified
// operation and difficulty level.
using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

[ WebService( Namespace = "http://www.deitel.com/", Description =
   "Web service that generates a math equation." ) ]
[ WebServiceBinding( ConformsTo = WsiProfiles.BasicProfile1_1 ) ]
public class Generator : System.Web.Services.WebService
{
   // Method to generate a math equation
   [ WebMethod( Description = "Method to generate a math equation." ) ]
   public Equation GenerateEquation( string operation, int level )
   {
      // find maximum and minimum number to be used
      int maximum = Convert.ToInt32( Math.Pow( 10, level ) );
      int minimum = Convert.ToInt32( Math.Pow( 10, level - 1 ) );

      // object to generate random numbers
      Random randomObject = new Random();

      // create equation consisting of two random
      // numbers between minimum and maximum parameters
      Equation equation = new Equation( 
         randomObject.Next( minimum, maximum ), 
         randomObject.Next( minimum, maximum ), operation );

      return equation;
   } // end method GenerateEquation
} // end class Generator

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/
