// Fig. 22.29: MathTutor.cs
// Math tutoring program using Web service to generate random equations.
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MathTutor
{
   public partial class MathTutorForm : Form
   {
      public MathTutorForm()
      {
         InitializeComponent();
      } // end constructor

      private string operation = "+";
      private int level = 1;
      private localhost.Equation equation; 
      private localhost.Generator generator = new localhost.Generator();

      // generates new equation when user clicks button
      private void generateButton_Click( object sender, EventArgs e )
      {
         // generate equation using current operation and level
         equation = generator.GenerateEquation( operation, level );

         // display left-hand side of equation
         questionLabel.Text = equation.LeftHandSide;

         okButton.Enabled = true;
         answerTextBox.Enabled = true;
      } // end method generateButton_Click

      // check user's answer
      private void okButton_Click( object sender, EventArgs e )
      {
         // determine correct result from Equation object
         int answer = equation.Result;

         if ( answerTextBox.Text == "" )
            return;

         // get user's answer
         int userAnswer = Int32.Parse( answerTextBox.Text );

         // determine whether user's answer is correct
         if ( answer == userAnswer )
         {
            questionLabel.Text = ""; // clear question
            answerTextBox.Text = ""; // clear answer
            okButton.Enabled = false; // disable OK button
            MessageBox.Show( "Correct! Good job!" );
         } // end if
         else
            MessageBox.Show( "Incorrect. Try again." );
      } // end method okButton_Click

      // set difficulty level to 1
      private void levelOneRadioButton_CheckedChanged( object sender, 
         EventArgs e )
      {
         level = 1;
      } // end method levelOneRadioButton_CheckedChanged

      // set difficulty level to 2
      private void levelTwoRadioButton_CheckedChanged( object sender, 
         EventArgs e )
      {
         level = 2;
      } // end method levelTwoRadioButton_CheckedChanged

      // set difficulty level to 3
      private void levelThreeRadioButton_CheckedChanged( object sender,
         EventArgs e )
      {
         level = 3;
      } // end method levelThreeRadioButton_CheckedChanged

      // set the operation to addition
      private void additionRadioButton_CheckedChanged( object sender, 
         EventArgs e )
      {
         operation = "+";
         generateButton.Text = 
            "Generate " + additionRadioButton.Text + " Example";
      } // end method additionRadioButton_CheckedChanged

      // set the operation to subtraction
      private void subtractionRadioButton_CheckedChanged( object sender, 
         EventArgs e )
      {
         operation = "-";
         generateButton.Text = "Generate " +
            subtractionRadioButton.Text + " Example";
      } // end method subtractionRadioButton_CheckedChanged

      // set the operation to multiplication
      private void multiplicationRadioButton_CheckedChanged(
         object sender, EventArgs e )
      {
         operation = "*";
         generateButton.Text = "Generate " +
            multiplicationRadioButton.Text + " Example";
      } // end method multiplicationRadioButton_CheckedChanged
   } // end class MathTutorForm
} // end namespace MathTutor

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/
